using FluentValidation;
using Indotalent.Shared.Consts;

namespace Indotalent.Features.Pipeline.Expense.Cqrs;

public class UpdateExpenseValidator : AbstractValidator<UpdateExpenseRequest>
{
    public UpdateExpenseValidator()
    {
        RuleFor(x => x.Id)
            .NotEmpty().WithMessage("ID is required for update");

        RuleFor(x => x.Title)
            .NotEmpty().WithMessage("Expense Title is required")
            .MaximumLength(GlobalConsts.StringLengthShort);

        RuleFor(x => x.CampaignId)
            .NotEmpty().WithMessage("Campaign is required");
    }

    public Func<object, string, Task<IEnumerable<string>>> ValidateValue() => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateExpenseRequest>.CreateWithOptions((UpdateExpenseRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid) return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}